unit uAnimais;

interface

uses
  Dialogs;

type
  ISerVivo = interface
  ['{328D4469-7A22-4ED2-934A-3BACD963FA0D}']
    procedure Respira;
    procedure AlimentaSe;
  end;

  IAnimal = interface(ISerVivo)
  ['{BC22C426-37B3-42C8-8ADE-59E6F9AFB21F}']
    procedure LocomoverSe;
  end;


  ICachorro = interface(IAnimal)
  ['{A6D9BC8F-0143-4875-970C-EEFC36A4B772}']
    procedure Latir;
  end;

  IBoi = interface(IAnimal)
  ['{3BBBC4A7-0FE7-42E8-93AB-1A3401F2B0DB}']
    procedure Mugir;
  end;

  TSerVivo = class abstract(TInterfacedObject, ISerVivo)
  public
    procedure Respira; virtual; abstract;
    procedure AlimentaSe; virtual; abstract;
  end;


  TAnimal = class abstract(TSerVivo, IAnimal)
  public
    procedure LocomoverSe; virtual; abstract;
  end;


  TCachorro = class(TAnimal, ICachorro)
  public
    //implementao de ISerVivo
    procedure Respira;     override;
    procedure AlimentaSe;  override;

    //implementao de IAnimal
    procedure LocomoverSe; override;

    //implementao de Icachorro
    procedure Latir;    virtual;
  end;

  TBoi = class(TAnimal, IBoi)
  public
    //implementao de ISerVivo
    procedure Respira;     override;
    procedure AlimentaSe;  override;

    //implementao de IAnimal
    procedure LocomoverSe;  override;

    //implementao de Iboi
    procedure Mugir;       virtual;
  end;

implementation

{ TBoi }

procedure TBoi.AlimentaSe;
begin
  ShowMessage('Comendo Capim');
end;

procedure TBoi.LocomoverSe;
begin
  ShowMessage('Boi Andando pesadamente');
end;

procedure TBoi.Mugir;
begin
  ShowMessage('Muuuuuuuuuuuuuuuuuu');
end;

procedure TBoi.Respira;
begin
  ShowMessage('Boi Respirando');
end;

{ TCachorro }

procedure TCachorro.AlimentaSe;
begin
  ShowMessage('Comendo Rao');
end;

procedure TCachorro.Latir;
begin
  ShowMessage('Au Au');
end;

procedure TCachorro.LocomoverSe;
begin
  ShowMessage('Cachorro Andando');
end;

procedure TCachorro.Respira;
begin
  ShowMessage('Cachorro Respirando');
end;

end.
