unit uComponentes;

interface
uses
  Classes,
  StdCtrls,
  ExtCtrls,
  SysUtils;



type
  IControle = interface
    ['{9B4989DE-A609-4D81-95EA-3EBFC24C7232}']
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;


  TCDEdit = class (TEdit, IControle)
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;

  TCDCheckBox = class (TCheckBox, IControle)
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;

  TCDMemo = class (TMemo, IControle)
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;

  TCDRadioButton = class (TRadioButton, IControle)
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;


  TCDRadioGroup = class (TRadioGroup, IControle)
    function Nome: string;
    function Classe: string;
    function ObtemValor: string;
  end;


  procedure Register;

implementation

{ TEditHelperInterfaced }

function TCDEdit.Classe: string;
begin
  Result := ClassName;
end;

function TCDEdit.Nome: string;
begin
  Result := Name;
end;

function TCDEdit.ObtemValor: string;
begin
  Result := Text;
end;

{ TCDCheckBox }

function TCDCheckBox.Classe: string;
begin
  Result := ClassName;
end;

function TCDCheckBox.Nome: string;
begin
  Result := Name;
end;

function TCDCheckBox.ObtemValor: string;
begin
  Result := BoolToStr(Checked, true);
end;

{ TCDMemo }

function TCDMemo.Classe: string;
begin
  Result := ClassName;
end;

function TCDMemo.Nome: string;
begin
  Result := Name;
end;

function TCDMemo.ObtemValor: string;
begin
  Result := Text;
end;

{ TCDRadioButton }

function TCDRadioButton.Classe: string;
begin
  Result := ClassName;
end;

function TCDRadioButton.Nome: string;
begin
  Result := Name;
end;

function TCDRadioButton.ObtemValor: string;
begin
  Result := Caption + ' = ' + BoolToStr(Checked, true);
end;

{ TCDRadioGroup }

function TCDRadioGroup.Classe: string;
begin
  Result := ClassName;
end;

function TCDRadioGroup.Nome: string;
begin
  Result := Name;
end;

function TCDRadioGroup.ObtemValor: string;
begin
  if ItemIndex > -1 then
    Result := Items[ItemIndex]
  else
    Result := 'Nenhum';
end;


procedure Register;
begin
  RegisterComponents('Clube Delphi',
  [TCDEdit, TCDCheckBox, TCDMemo, TCDRadioButton, TCDRadioGroup]);
end;

end.
