unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,

  uVeiculos,
  uAnimais,
  uVeiculosTracaoAnimal,
  uComponentes;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    mControles: TMemo;
    Label1: TLabel;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FazVeiculoAndar(veiculo: IVeiculo);
    procedure AlimentaSerVivo(servivo: ISerVivo);
    function ObtemValor(const nome: string): string;
  end;

  TUmaClasse = class
  strict private
    FUmaData: TDateTime;
    FUmNumero: integer;
    FUmNome: string;
    FUmaFracao: Double;
    FUmBooleano: boolean;
    procedure UmMetodoPrivado;
    property Data: TDateTime read FUmaData write FUmaData;
  public
    procedure SetNome(const value: string);
    function GetNome: string;
    procedure DigaAlo;
    property Nome: string read GetNome write SetNome;
  end;

  TUmaClasseAbstrata = class abstract
  public
    procedure TesteAbstract; virtual; abstract;
    procedure TesteConcreto; virtual;
    Constructor Create; virtual; abstract;
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

{ TUmaClasse }

procedure TUmaClasse.DigaAlo;
begin
  ShowMessage('Ol, eu sou ' + FUmNome);
end;

function TUmaClasse.GetNome: string;
begin
  Result := FUmNome;
end;

procedure TUmaClasse.SetNome(const value: string);
begin
  FUmNome := value;
end;

procedure TUmaClasse.UmMetodoPrivado;
begin
  ShowMessage('Eu no devo ser visto de fora da minha classe');
end;



procedure TForm1.Button1Click(Sender: TObject);
var
  UmObjeto: TUmaClasse;
begin
  UmObjeto := TUmaClasse.Create;

  //atributos comentados no so visveis com strict private

  //UmObjeto.FUmaData := now;
  //UmObjeto.FUmNumero := 5;
  //UmObjeto.FUmNome := 'Vitor';
  //UmObjeto.FUmaFracao := 3/5;
  //UmObjeto.FUmBooleano := true;
  //UmObjeto.UmMetodoPrivado;
  //UmObjeto.Data := now;

  UmObjeto.SetNome('Luiz');
  UmObjeto.Nome :=  'Rubio';
  UmObjeto.DigaAlo;
  UmObjeto.Free;
end;

procedure TForm1.AlimentaSerVivo(servivo: ISerVivo);
begin
  servivo.AlimentaSe;
end;

procedure TForm1.FazVeiculoAndar(veiculo: IVeiculo);
begin
  veiculo.DeslocarSe;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  cb: TCDCheckBox;
  rb1: TCDRadioButton;
  rb2: TCDRadioButton;
  ed: TCDEdit;
  mem: TCDMemo;
  rg: TCDRadioGroup;
begin

  cb := TCDCheckBox.Create(Self);
  cb.Name := 'cbEmbrulharPresente';
  cb.Caption := 'Embrulhar para Presente';
  cb.Left := 10;
  cb.Top := 1;
  cb.Width := 200;
  cb.Parent := Self;

  rb1 := TCDRadioButton.Create(Self);
  rb1.Name := 'cdrbCartao1';
  rb1.Caption := 'Usar Visa';
  rb1.Left := 10;
  rb1.Top := 30;
  rb1.Parent := Self;

  rb2 := TCDRadioButton.Create(Self);
  rb2.Name := 'cdrbCartao2';
  rb2.Caption := 'Usar Master';
  rb2.Left := 10;
  rb2.Top := 60;
  rb2.Parent := Self;

  ed := TCDEdit.Create(Self);
  ed.Name := 'edNumCartao';
  ed.Left := 10;
  ed.Top := 100;
  ed.Parent := Self;

  mem := TCDMemo.Create(Self);
  mem.Name := 'mObservacao';
  mem.Left := 10;
  mem.Top := 150;
  mem.Parent := Self;

  rg := TCDRadioGroup.Create(Self);
  rg.Name := 'rgPagamento';
  rg.Caption := 'Forma de Pagamento';
  rg.Left := 10;
  rg.Top := 250;
  rg.Parent := Self;
  rg.Items.Add('A vista');
  rg.Items.Add('2 x');
  rg.Items.Add('3 x');

end;

function TForm1.ObtemValor(const nome: string): string;
var
  controle: IControle;
begin

  if Supports(FindComponent(nome), IControle, Controle) then
    Result := controle.ObtemValor
  else
    Result := 'Null'; //pode ser um string vazio ou um exception

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  carroca: IVeiculo;
  boi: IBoi;
  UmAnimal: IAnimal;
  UmSerVivo: ISerVivo;
begin

  boi := TBoi.Create;
  carroca := TCarroca.Create(boi); //experimente passar nil

  //boi  Ianimal e IServivo e pode ser convertido com "as"
  (boi as IServivo).AlimentaSe;
  (boi as IAnimal).LocomoverSe;

  //boi tambm pode ser convertido diretamente
  UmAnimal := boi;
  UmSerVivo := boi;
  UmSerVivo.AlimentaSe;
  UmAnimal.LocomoverSe;

  //mtodo no funcionar sem um objeto TBoi ou qualquer um que implemente IBoi
  carroca.DeslocarSe;

  //os mtodos abaixo aceitam qualquer veiculo ou ser vivo, respectivamente
  FazVeiculoAndar(carroca);
  AlimentaSerVivo(carroca as IBoi);  //falhar se no houver um boi

  //se a carroa no tiver um boi os mtodos abaixo no sero suportados
  (carroca as IBoi).Mugir;
  (carroca as IBoi).LocomoverSe;
  (carroca as IBoi).Respira;
  (carroca as IBoi).AlimentaSe;

  if carroca is TVeiculoTracaoAnimal then
    ShowMessage('carroca  um veculo de trao animal');

  if carroca is TCarroca then
    ShowMessage('carroca  uma carroa');

  if boi is TBoi then
    ShowMessage('boi  do tipo TBoi');

  if carroca is TBoi then
    ShowMessage('carroca  do tipo TBoi')
  else
    ShowMessage('carroca NO  do tipo TBoi');

  if Supports(carroca, IVeiculo) then
    ShowMessage('carroca suporta a interface IVeiculo');

  if Supports(carroca, IBoi) then
    ShowMessage('carroca implementa boi atravs da propriedade Animal');

  if Supports(boi, IBoi) then
    ShowMessage('boi suporta a interface IBoi');

  //UmAnimal := carroca as IBoi;
  if Supports(carroca, IBoi, UmAnimal) then
  begin
    UmAnimal.LocomoverSe;
    UmAnimal.Respira;
    UmAnimal.AlimentaSe;
  end;

  //UmSerVivo := carroca as IBoi;
  if Supports(carroca, IBoi, UmSerVivo) then
  begin
    UmSerVivo.Respira;
    UmSerVivo.AlimentaSe;
  end;

  //mtodos que daro abstract error
  //AlimentaSerVivo(carroca as IAnimal);
  //AlimentaSerVivo(carroca as IserVivo);
  //(carroca as IAnimal).LocomoverSe;
  //(carroca as IAnimal).Respira;
  //(carroca as IAnimal).AlimentaSe;
  //if Supports(carroca, IAnimal) then
  //  ShowMessage('carroca implementa boi atravs da propriedade Animal');
  //if Supports(carroca, ISerVivo) then
  //  ShowMessage('carroca implementa boi atravs da propriedade Animal');

end;



procedure TForm1.Button3Click(Sender: TObject);
var
  objAviao: TAviao;
  objCarro: TCarro;
  objBarco: TBarco;
  UmObjetoQualquer: TInterfacedObject;

  OutroVeiculo: IVeiculo;
  OutroCarro: ICarro;
  OutroBarco: IBarco;
  UmSerVivo: ISerVivo;

begin

  //cria os objetos e os mantem com referencia em uma variavel do tipo objeto
  objaviao:= TAviao.Create;
  objCarro:= TCarro.Create;
  objBarco:= Tbarco.Create;
  UmObjetoQualquer := TCarro.Create;

  //aqui tanto faz chamar os mtodos diretamente pelo ojeto ou transformando-os em uma interface com typecast
  //objAviao.Voar;
  //objCarro.Rodar;
  //objBarco.Velejar;

  //(objAviao as IAviao).Voar;
  //(objCarro as ICarro).Rodar;
  //(objBarco as IBarco).Velejar;
  //(UmObjetoQualquer as ICarro).Rodar;

  //no se deve fazer isso direto com os objetos a no ser que exista uma interface apontando para eles
  //fazendo isso o contador de referencia pode zerar
  FazVeiculoAndar(objaviao); //saindo do escopo dessa funo o argumento atinge refcount zero, destruindo objaviao sem ligar para sua referencia objaviao fora da funo
  FazVeiculoAndar(objCarro); //saindo do escopo dessa funo o argumento atinge refcount zero, destruindo objCarro sem ligar para sua referencia objCarro fora da funo
  FazVeiculoAndar(objBarco); //saindo do escopo dessa funo o argumento atinge refcount zero, destruindo objBarco sem ligar para sua referencia objBarco fora da funo

  //a partir daqui os objetos no funcionam mais porque o contador de referncia foi zerado enquanto o objeto foi
  //convertido para interface
  objAviao.Voar;
  objCarro.Rodar;
  objBarco.Velejar;

  //a partir daqui o erro pode ocorrer a qualquer momento
  (objAviao as IAviao).Voar;
  (objCarro as ICarro).Rodar;
  (objBarco as IBarco).Velejar;
  (UmObjetoQualquer as ICarro).Rodar;

  if Supports(UmObjetoQualquer.ClassType, IVeiculo) then
  begin
    ShowMessage('UmObjetoQualquer suporta a interface IVeiculo');
    (UmObjetoQualquer as IVeiculo).DeslocarSe;
    FazVeiculoAndar(UmObjetoQualquer as IVeiculo);
    OutroVeiculo := (UmObjetoQualquer   as IVeiculo);
    OutroVeiculo.DeslocarSe;
  end;

  if Supports(UmObjetoQualquer.ClassType, ICarro) then
  begin
    ShowMessage('UmObjetoQualquer suporta a interface ICarro');
    (UmObjetoQualquer as ICarro).DeslocarSe;
    FazVeiculoAndar(UmObjetoQualquer as ICarro);
    OutroVeiculo := (UmObjetoQualquer as ICarro);
    OutroVeiculo.DeslocarSe;
  end;

  if Supports(UmObjetoQualquer, IVeiculo, OutroVeiculo) then
  begin
    ShowMessage('UmObjetoQualquer suporta a interface IVeiculo');
    FazVeiculoAndar(OutroVeiculo);
  end;

  if Supports(UmObjetoQualquer, ICarro, OutroVeiculo) then
  begin
    ShowMessage('UmObjetoQualquer suporta a interface ICarro');
    FazVeiculoAndar(OutroVeiculo);
  end;

  //sabe-se que UmObjetoQualquer  um  ICarro
  //usando operador "as" para typecast

  try
   OutroCarro := nil;
   OutroCarro := (UmObjetoQualquer as ICarro);
  except
    on EIntfCastError do
         ShowMessage('Interface Errada');
  end;
  if OutroCarro <> nil then
    OutroCarro.Rodar;

  try
   OutroBarco := nil;
   OutroBarco := (UmObjetoQualquer as IBarco);
  except
    on EIntfCastError do
         ShowMessage('Interface Errada');
  end;
  if OutroBarco <> nil then
    OutroBarco.Velejar;


  try
   OutroVeiculo := nil;
   OutroVeiculo := (UmObjetoQualquer as IVeiculo);
  except
    on EIntfCastError do
         ShowMessage('Interface Errada');
  end;
  if OutroVeiculo <> nil then
    OutroVeiculo.DeslocarSe;

  if UmObjetoQualquer.GetInterface(IVeiculo, OutroVeiculo) then
    OutroVeiculo.DeslocarSe;

  if UmObjetoQualquer.GetInterface(ISerVivo, UmSerVivo)  then
    UmSerVivo.AlimentaSe;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
  aviao: IAviao;
  carro: ICarro;
  barco: IBarco;
  outroObjAviao: TAviao;
  outroObjCarro: TCarro;
  outroObjBarco: TBarco;
  UmInterfacedObject: TInterfacedObject;
  UmObjeto: TObject;
begin

  aviao:= TAviao.Create;
  carro:= TCarro.Create;
  barco:= Tbarco.Create;

  //converso interface/objeto com AS
  if aviao is TAviao then
  begin
    ShowMessage('Avio  um TAviao');
    outroObjAviao := (aviao as TAviao);
    outroObjAviao.Voar;
  end;

  //converso interface/objeto com AS
  if carro is TCarro then
  begin
    ShowMessage('Carro  um TCarro');
    outroObjCarro := (carro as TCarro);
    outroObjCarro.Rodar;
  end;


  //converso interface/objeto com AS
  if barco is Tbarco then
  begin
    ShowMessage('barco  um Tbarco');
    outroObjbarco := (barco as Tbarco);
    outroObjbarco.Velejar;
  end;


  //converso errada
  outroObjbarco := nil;
  try
    outroObjbarco := (carro as Tbarco);
  except
    on EInvalidCast do
      ShowMessage('Tipo Errado');
  end;
  if outroObjbarco <> nil then
    outroObjBarco.Velejar;


  if carro is TInterfacedObject then
  begin
    ShowMessage('carro  um TInterfacedObject');
    UmInterfacedObject := (carro as TInterfacedObject);
    ShowMessage('Classe: ' + UmInterfacedObject.ClassName);
  end;

  if carro is TObject then
  begin
    ShowMessage('carro  um TObject');
    UmObjeto := (carro as TObject);
    ShowMessage('Classe: ' + UmObjeto.ClassName);
  end;

end;

procedure TForm1.Button5Click(Sender: TObject);
var c:TUmaClasseAbstrata;
begin
  c := TUmaClasseAbstrata.Create;
  c.TesteConcreto;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  i: integer;
  controle: IControle;
begin

  for i := 0 to ControlCount -1 do
    if Supports(Controls[i], IControle, controle) then
      mControles.Lines.Add(
        'Nome: ' + controle.Nome + #13#10 +
        'Classe: ' + controle.Classe + #13#10 +
        'Valor: ' + controle.ObtemValor
      );


end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  mControles.Lines.Add(
   ObtemValor( InputBox('Digite o nome de um campo', 'Nome do Campo', ''))
  );
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  aviao: IAviao;
  carro: ICarro;
  barco: IBarco;

  OutroVeiculo: IVeiculo;

begin

  //converso objeto/interface
  aviao := TAviao.Create;;
  carro := TCarro.Create;
  barco := Tbarco.Create;

  //isso seria o correto
  FazVeiculoAndar(aviao);
  FazVeiculoAndar(carro);
  FazVeiculoAndar(barco);

  aviao.Voar;
  carro.Rodar;
  barco.Velejar;


  if (aviao is TAviao) then
  begin
    ShowMessage('Avio  um TAviao');
    (aviao as TAviao).DeslocarSe;
  end;

  if (carro is TCarro) then
  begin
    ShowMessage('Carro  um TCarro');
    (carro as TCarro).DeslocarSe;
  end;

  if (barco is TBarco) then
  begin
    ShowMessage('barco  um TBarco');
    (barco as TBarco).DeslocarSe;
  end;

  if carro.QueryInterface(IVeiculo,OutroVeiculo) = S_OK  then
    OutroVeiculo.DeslocarSe;

  if barco.QueryInterface(IVeiculo,OutroVeiculo) = S_OK  then
    OutroVeiculo.DeslocarSe;

  if aviao.QueryInterface(IVeiculo,OutroVeiculo) = S_OK  then
    OutroVeiculo.DeslocarSe;


end;

{ TUmaClasseAbstrata }

procedure TUmaClasseAbstrata.TesteConcreto;
begin
  ShowMessage('Este  um mtodo concreto desnecessrio que no deveria existir');
end;

end.
