unit uVeiculos;

interface

uses
  Dialogs, sysutils;

type
  IVeiculo = interface(IInterface)
  ['{3207B810-D5A8-4A72-97DE-005376FE7456}']
    procedure DeslocarSe;
  end;

  ICarro = interface(IVeiculo)
  ['{930BA9FB-0627-4916-87C4-5E16E5AAA9B3}']
    procedure Rodar;
  end;

  IBarco = interface(IVeiculo)
  ['{081FEAED-045D-40F5-82A1-2F7262C89635}']
    procedure Velejar;
  end;

  IAviao = interface(IVeiculo)
  ['{8201B7A4-5350-44E5-8F2A-72C05B121A55}']
    procedure Voar;
  end;

  TVeiculo = class abstract(TInterfacedObject, IVeiculo)
  public
    procedure DeslocarSe; virtual; abstract;
  end;

  TAviao = class(TVeiculo, IAviao)
  public
    procedure DeslocarSe; override;
    procedure Voar;
  end;

  TBarco = class(TVeiculo, IBarco)
  public
    procedure DeslocarSe; override;
    procedure Velejar;
  end;

  TCarro = class(TVeiculo, ICarro)
  public
    procedure DeslocarSe; override;
    procedure Rodar;
  end;

implementation




{ TAviao }

procedure TAviao.DeslocarSe;
begin
  ShowMessage('Avio deslocando-se. ' + IntToStr(self.RefCount) + ' Referncias');
end;

procedure TAviao.Voar;
begin
  ShowMessage('Voando');
  DeslocarSe;
end;

{ TBarco }

procedure TBarco.DeslocarSe;
begin
  ShowMessage('Barco Deslocando-se. ' + IntToStr(self.RefCount) + ' Referncias');
end;

procedure TBarco.Velejar;
begin
  ShowMessage('Velejando. ' + IntToStr(self.RefCount) + ' Referncias');
  DeslocarSe;
end;

{ TCarro }

procedure TCarro.DeslocarSe;
begin
  ShowMessage('Carro Deslocando-se. ' + IntToStr(self.RefCount) + ' Referncias');
end;

procedure TCarro.Rodar;
begin
  ShowMessage('Rodando. ' + IntToStr(self.RefCount) + ' Referncias');
  DeslocarSe;
end;

end.
