unit uVeiculosTracaoAnimal;

interface

uses
  Dialogs,
  uAnimais,
  uVeiculos;

type

  TVeiculoTracaoAnimal =  class abstract(TInterfacedObject, IVeiculo, IAnimal, ISerVivo)
  private
    function GetAnimal: IAnimal;   virtual; abstract;
    procedure SetAnimal(const value: IAnimal);  virtual;  abstract;
  public
    constructor Create(const OAnimal: IAnimal); virtual; abstract;

    //mtodos prprios
    procedure Andar;  virtual; abstract;
    //mtodos de IVeiculo
    procedure DeslocarSe; virtual; abstract;
    //no  necessrio implementar
    property Animal: IAnimal read GetAnimal write SetAnimal implements IAnimal, ISerVivo;
  end;


  TTreno = class(TVeiculoTracaoAnimal, ICachorro)
  private
    FAnimal: ICachorro;
    function GetAnimal: ICachorro;  reintroduce;
    procedure SetAnimal(const value: ICachorro);   reintroduce;
  public
    constructor Create(const OAnimal: ICachorro); reintroduce;
    //mtodos prprios
    procedure Andar;  override;
    //mtodos de IVeiculo
    procedure DeslocarSe; override;
    //no  necessrio implementar
    property Animal: ICachorro read GetAnimal write SetAnimal implements ICachorro;
  end;

  TCarroca = class(TVeiculoTracaoAnimal, IBoi)
  private
    FAnimal: IBoi;
    function GetAnimal: IBoi; reintroduce;
    procedure SetAnimal(const value: IBoi);  reintroduce;
  public
    constructor Create(const OAnimal: IBoi); reintroduce;
    //mtodos prprios
    procedure Andar;  override;
    //mtodos de IVeiculo
    procedure DeslocarSe; override;
    //no  necessrio implementar
    property Animal: IBoi read GetAnimal write SetAnimal implements IBoi;
  end;

implementation

{ TTreno }

procedure TTreno.Andar;
begin
  Self.DeslocarSe;
end;

constructor TTreno.Create(const OAnimal: ICachorro);
begin
  FAnimal := OAnimal;
end;

procedure TTreno.DeslocarSe;
begin
  if Assigned(FAnimal) then
    FAnimal.LocomoverSe
  else
    ShowMessage('Falta um co pra puxar esse tren');
end;

function TTreno.GetAnimal: ICachorro;
begin
  Result := FAnimal;
end;

procedure TTreno.SetAnimal(const value: ICachorro);
begin
  FAnimal := value;
end;

{ TCarroca }

procedure TCarroca.Andar;
begin
  Self.DeslocarSe;
end;

constructor TCarroca.Create(const OAnimal: IBoi);
begin
  FAnimal := OAnimal;
end;

procedure TCarroca.DeslocarSe;
begin
  if Assigned(FAnimal) then
    FAnimal.LocomoverSe
  else
    ShowMessage('Falta um boi pra puxar essa carroa');
end;

function TCarroca.GetAnimal: IBoi;
begin
  Result := FAnimal;
end;

procedure TCarroca.SetAnimal(const value: IBoi);
begin
  FAnimal := value;
end;


end.
